## sox 1.0

=== DESCRIPTION ===
Package: sox
Type: Package
Title: Structured Learning in Time-Dependent Cox Models
Version: 1.0
Date: 2023-03-21
Authors@R: c(person("Yi", "Lian", role = c("aut", "cre"), email = "yi.lian@mail.mcgill.ca"),
             person("Guanbo", "Wang", role = "aut"),
             person("Archer Y.", "Yang", role = "aut"),
             person("Mireille E.", "Schnitzer", role = "aut"),
             person("Robert W.", "Platt", role = "aut"),
             person("Rui", "Wang", role = "aut"),
             person("Marc", "Dorais", role = "aut"),
             person("Sylvie", "Perreault", role = "aut"),
             person("Julien", "Mairal", role = "ctb"),
             person("Yuansi", "Chen", role = "ctb"))
Description: Efficient procedures for fitting and cross-validating the structurally-regularized time-dependent Cox models. The penalty term is a weighted sum of infinity norms of (overlapping) groups of coefficients, which can select variables following a user-specified grouping structure.
License: GPL (>= 3)
Encoding: UTF-8
Depends: R (>= 3.5.0), survival, glmnet
Imports: Rcpp (>= 1.0.10)
LinkingTo: Rcpp
Suggests: testthat (>= 3.0.0)
Config/testthat/edition: 3
RoxygenNote: 7.2.3
LazyData: true
Copyright: file inst/COPYRIGHTS
NeedsCompilation: yes
Packaged: 2023-03-21 21:07:16 UTC; YLIAN
Author: Yi Lian [aut, cre],
  Guanbo Wang [aut],
  Archer Y. Yang [aut],
  Mireille E. Schnitzer [aut],
  Robert W. Platt [aut],
  Rui Wang [aut],
  Marc Dorais [aut],
  Sylvie Perreault [aut],
  Julien Mairal [ctb],
  Yuansi Chen [ctb]
Maintainer: Yi Lian <yi.lian@mail.mcgill.ca>
Repository: CRAN
Date/Publication: 2023-03-22 09:00:02 UTC

## sox 1.1

=== DESCRIPTION ===
Package: sox
Type: Package
Title: Structured Learning in Time-Dependent Cox Models
Version: 1.1
Date: 2023-12-10
Authors@R: c(person("Yi", "Lian", role = c("aut", "cre"), email = "yi.lian@mail.mcgill.ca"),
             person("Guanbo", "Wang", role = "aut"),
             person("Archer Y.", "Yang", role = "aut"),
             person("Mireille E.", "Schnitzer", role = "aut"),
             person("Robert W.", "Platt", role = "aut"),
             person("Rui", "Wang", role = "aut"),
             person("Marc", "Dorais", role = "aut"),
             person("Sylvie", "Perreault", role = "aut"),
             person("Julien", "Mairal", role = "ctb"),
             person("Yuansi", "Chen", role = "ctb"))
Description: Efficient procedures for fitting and cross-validating the structurally-regularized time-dependent Cox models.
License: GPL (>= 3)
Encoding: UTF-8
Depends: R (>= 3.5.0), survival, glmnet
Imports: Rcpp (>= 1.0.10)
LinkingTo: Rcpp
Suggests: testthat (>= 3.0.0)
Config/testthat/edition: 3
RoxygenNote: 7.2.3
LazyData: true
Copyright: file inst/COPYRIGHTS
NeedsCompilation: yes
Packaged: 2023-12-11 17:13:39 UTC; YLIAN
Author: Yi Lian [aut, cre],
  Guanbo Wang [aut],
  Archer Y. Yang [aut],
  Mireille E. Schnitzer [aut],
  Robert W. Platt [aut],
  Rui Wang [aut],
  Marc Dorais [aut],
  Sylvie Perreault [aut],
  Julien Mairal [ctb],
  Yuansi Chen [ctb]
Maintainer: Yi Lian <yi.lian@mail.mcgill.ca>
Repository: CRAN
Date/Publication: 2023-12-11 17:30:02 UTC

## sox 1.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: sox
 Type: Package
 Title: Structured Learning in Time-Dependent Cox Models
-Version: 1.1
-Date: 2023-12-10
+Version: 1.2
+Date: 2024-07-10
 Authors@R: c(person("Yi", "Lian", role = c("aut", "cre"), email = "yi.lian@mail.mcgill.ca"),
              person("Guanbo", "Wang", role = "aut"),
              person("Archer Y.", "Yang", role = "aut"),
@@ -21,11 +21,11 @@
 LinkingTo: Rcpp
 Suggests: testthat (>= 3.0.0)
 Config/testthat/edition: 3
-RoxygenNote: 7.2.3
+RoxygenNote: 7.3.1
 LazyData: true
 Copyright: file inst/COPYRIGHTS
 NeedsCompilation: yes
-Packaged: 2023-12-11 17:13:39 UTC; YLIAN
+Packaged: 2024-07-10 16:02:00 UTC; YLIAN
 Author: Yi Lian [aut, cre],
   Guanbo Wang [aut],
   Archer Y. Yang [aut],
@@ -38,4 +38,4 @@
   Yuansi Chen [ctb]
 Maintainer: Yi Lian <yi.lian@mail.mcgill.ca>
 Repository: CRAN
-Date/Publication: 2023-12-11 17:30:02 UTC
+Date/Publication: 2024-07-15 18:50:02 UTC

## sox 1.2.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: sox
 Type: Package
 Title: Structured Learning in Time-Dependent Cox Models
-Version: 1.2
-Date: 2024-07-10
+Version: 1.2.1
+Date: 2024-12-03
 Authors@R: c(person("Yi", "Lian", role = c("aut", "cre"), email = "yi.lian@mail.mcgill.ca"),
              person("Guanbo", "Wang", role = "aut"),
              person("Archer Y.", "Yang", role = "aut"),
@@ -25,7 +25,7 @@
 LazyData: true
 Copyright: file inst/COPYRIGHTS
 NeedsCompilation: yes
-Packaged: 2024-07-10 16:02:00 UTC; YLIAN
+Packaged: 2024-12-04 03:05:49 UTC; YLIAN
 Author: Yi Lian [aut, cre],
   Guanbo Wang [aut],
   Archer Y. Yang [aut],
@@ -38,4 +38,4 @@
   Yuansi Chen [ctb]
 Maintainer: Yi Lian <yi.lian@mail.mcgill.ca>
 Repository: CRAN
-Date/Publication: 2024-07-15 18:50:02 UTC
+Date/Publication: 2024-12-04 05:40:01 UTC

## sox 1.2.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: sox
 Type: Package
 Title: Structured Learning in Time-Dependent Cox Models
-Version: 1.2.1
-Date: 2024-12-03
+Version: 1.2.2
+Date: 2025-05-07
 Authors@R: c(person("Yi", "Lian", role = c("aut", "cre"), email = "yi.lian@mail.mcgill.ca"),
              person("Guanbo", "Wang", role = "aut"),
              person("Archer Y.", "Yang", role = "aut"),
@@ -25,7 +25,7 @@
 LazyData: true
 Copyright: file inst/COPYRIGHTS
 NeedsCompilation: yes
-Packaged: 2024-12-04 03:05:49 UTC; YLIAN
+Packaged: 2025-05-07 18:20:11 UTC; YLIAN
 Author: Yi Lian [aut, cre],
   Guanbo Wang [aut],
   Archer Y. Yang [aut],
@@ -38,4 +38,4 @@
   Yuansi Chen [ctb]
 Maintainer: Yi Lian <yi.lian@mail.mcgill.ca>
 Repository: CRAN
-Date/Publication: 2024-12-04 05:40:01 UTC
+Date/Publication: 2025-05-07 18:40:01 UTC

## sox 13.0.0-1build1-maemo1

=== debian/changelog ===
sox (13.0.0-1build1-maemo1) unstable; urgency=low

  * Removed dependencies to mad, samplerate, sndfile, gsm, etc.

 -- Terje Bergstrom <terje@terje.fi>  Sun, 30 Sep 2007 09:26:59 +0300

sox (13.0.0-1build1) gutsy; urgency=low

  * Rebuild for libflac transition.

 -- Steve Kowalik <stevenk@ubuntu.com>  Tue,  3 Jul 2007 11:59:21 +1000

sox (13.0.0-1) unstable; urgency=low

  * New upstream version:
    - Huge amount of changes (closes: #345726, #274519, #257525).
    - Please see the upstream changelog.
    - Warning: some scripts may break with this new version.
    - Guenter set as co-maintainer.
    - soxmix no longer exists (closes:  #349178, #374096).
  * Taking over the package with Guenter's permission.
    - Thanks alot for all those years of maintenance!
  * [debian/control]:
    - Added build-depends on libsamplerate0-dev, libgsm1-dev and
      libsndfile1-dev.
    - Added !kfreebsd-amd64 to libasound2-dev (closes: #361487).
  * [debian/patches]: No more patches, everything is fixed upstream.
  * [debian/rules]: 
    - Added -D_REENTRANT as required by policy on libraries.
    - Added -Wl,-z,defs to enforce symbol resolution at build time.
    - Disabled shared library for now, see README.Debian.
  * [debian/README.Debian]:
    - Added instructions to build from CVS.
    - Added information as to why shared lib is disabled for now.

 -- Pascal Giard <pascal@debian.org>  Fri, 23 Feb 2007 12:07:50 -0500

sox (12.18.2-2) unstable; urgency=low

  * [debian/patches/01_fix_draining.patch]:
    - Unofficial patch from upstream that fixes all effects relying on
      draining. Thanks to Chris Bagwell <chris@cnpbagwell.com>.
  * [debian/copyright]: Removed reminiscence of the old version.
  * [debian/patches/03_fix_manpage_typos.patch]:
    - Fixed typos in sox.1 and play.1 manpages. Thanks to 
      A. Costa <agcosta@gis.net> (closes: #404290, #404288).

 -- Pascal Giard <pascal@debian.org>  Sat, 23 Dec 2006 14:09:53 -0500
	

sox (12.18.2-1) unstable; urgency=low

  * Changes by Pascal Giard <pascal@debian.org>
    - New upstream version (closes: #397388, #374369).
    - [debian/rules]: Compiling with -fPIC (closes: #390715).
    - [debian/control]: Standards-Version bumped to 3.7.2, -fPIC was required.
    - [debian/copyright]: Fixed license attribution (closes: #398723).
    - [debian/patches/06_eof.patch]: Deleted, fixed upstream.
  * Fixed date format in changelog
    - New upstream version (closes: #336542, #402862)

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Tue,  5 Dec 2006 18:40:43 +0100

sox (12.17.9-1) unstable; urgency=low

  * New upstream version
  * Added ALSA support
  * Use play script from version 12.17.18 with multiple file support, I 
    do not dare to switch to the new behaviour and ALSA by default yet.

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Thu, 15 Dec 2005 12:47:16 +0100

sox (12.17.8-1) unstable; urgency=low

  * New upstream version
  * New standards version

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Thu, 22 Sep 2005 14:31:55 +0200

sox (12.17.7-2) unstable; urgency=low

  * Moved ststdint.h to -dev package
  * fixed disk full problem (0_eof.patch) (closes: #313206)
  * sox-dev replaces earlier sox versions, upgrading should be save
    (closes: #162942)
  * sox-dev includes st.h, st_i.h is only meant for sox internal use
    (closes: #254846)
  * Problem with rec script fixed upstream (closes: #272080)
  * Added soxexam.1 manpage (closes: #307661)
  * Applied patch for fixing -x behaviour (closes: #316346)
  * Applied manpage typo patch (closes: #302819)

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Fri, 15 Jul 2005 18:22:03 +0200

sox (12.17.7-1) unstable; urgency=low

  * New upstream version
  * removed free comment patch
  * OGG serial number bug fixed upstream (closes: #277288)
  * Added headers for -dev package in .install file (closes: #254846)

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Fri, 18 Mar 2005 12:43:34 +0100

sox (12.17.5-4) unstable; urgency=low

  * Disabled broken ALSA support (closes: #274151)

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Fri,  8 Oct 2004 19:16:37 +0200

sox (12.17.5-3) unstable; urgency=low

  * removed free() call for ft->format in wav.c (closes: #267147)

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Tue, 24 Aug 2004 10:57:44 +0200

sox (12.17.5-2) unstable; urgency=low

  * Fixed the dangling symlink problem (closes: #266301)

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Tue, 17 Aug 2004 15:29:00 +0200

sox (12.17.5-1) unstable; urgency=low

  * New upstream release
  * moved to patch system (for Debian applied patches see debian/patches)
  * added watch file
  * added Homepage in control file

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Sun, 15 Aug 2004 22:28:45 +0200

sox (12.17.4-9) unstable; urgency=low

  * Applied security patch (http://secunia.com/advisories/12175/)
    (closes: 262083)
  * Applied patch to resample.c for correct function definitino (closes:
    262085) thanks to Adam Majer
  * Fixed vorbis debug output (closes: 250272)
  * patched vorbis.c to create correct comment entries (closes: 244163)

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Fri, 30 Jul 2004 13:47:29 +0200

sox (12.17.4-8) unstable; urgency=low

  * patched wav.c with datalength patch. Thanks to Steven Critchfield
    (closes: 238794)
  * sox.1 manpage now documents the correct default bahaviour
    (logarithmic) for fade effect (closes: 140573)
  * Compand effect seems to be fixed upstream (closes: 216791)
  * remove documentation for split effect from manpage. split doesn't
    exist (closes: 220194)
  * Disabled passing of options to sox (for consistency) (closes:
    241653)
  * patched swap effect, fixes usage of swap with parameters 1 1
    (closes: 242051)
  * Updated play.1 man page (fixed wording)

 -- Guenter Geiger (Debian/GNU) <geiger@debian.org>  Mon,  5 Apr 2004 11:12:48 +0200

sox (12.17.4-7) unstable; urgency=low



=== debian/control ===
Source: sox
Section: sound
Priority: optional
Maintainer: Pascal Giard <pascal@debian.org>
Uploaders: Guenter Geiger (Debian/GNU) <geiger@debian.org>
Build-Depends: debhelper (>= 1.2.64), cdbs, libasound2-dev [!kfreebsd-i386 !kfreebsd-amd64]
Standards-Version: 3.7.2

Package: sox
Architecture: any
Depends: ${shlibs:Depends}
Description: Swiss army knife of sound processing
 SoX is a command line utility that can convert various formats of computer 
 audio files in to other formats. It can also apply various effects to these 
 sound files during the conversion. As an added bonus, SoX can play and record 
 audio files on several unix-style platforms.
 .
 SoX is able to handle formats like .ogg (vorbis), mp3, wav, aiff, voc, snd, au,
 gsm and several more.
 .
 Homepage: http://sox.sourceforge.net

Package: sox-dev
Architecture: any
Section: devel
Depends: sox (=${Source-Version}), ${shlibs:Depends}
Conflicts: libst-dev
Description: Development files for the SoX library
 SoX is the swiss army knife of sound processing.
 .
 This package contains the development files for the SoX library.
 .
 Homepage: http://sox.sourceforge.net

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

DEB_TAR_SRCDIR := sox-13.0.0

include /usr/share/cdbs/1/rules/tarball.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
#include /usr/share/cdbs/1/rules/simple-patchsys.mk

DEB_CONFIGURE_SCRIPT_ENV += CFLAGS="-fPIC -D_REENTRANT" LDFLAGS="-Wl,-z,defs"
DEB_CONFIGURE_EXTRA_FLAGS := --disable-lame --disable-shared

=== debian/watch ===
version=2
http://heanet.dl.sourceforge.net/sourceforge/sox/sox-(.*)\.tar\.gz

## sox 14.0.1

=== CMakeLists.txt ===
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckLibraryExists)

macro(optional variable header library function source)
  check_include_files(${header} ${variable}1)
  if (${variable}1)
    check_library_exists(${library} ${function} "" ${variable})
    if (${variable})
      set(optional_srcs ${optional_srcs} ${source})
      set(optional_libs ${optional_libs} ${library})
    endif (${variable})
  endif (${variable}1)
endmacro(optional)

macro(optional3 variable header library1 function1 library2 function2 library3 function3 source)
  check_include_files(${header} ${variable}1)
  if (${variable}1)
    check_library_exists(${library1} ${function1} "" ${variable}2)
    if (${variable}2)
      check_library_exists(${library2} ${function2} "" ${variable}3)
      if (${variable}3)
	check_library_exists(${library3} ${function3} "" ${variable})
        if (${variable})
          set(optional_srcs ${optional_srcs} ${source})
          set(optional_libs ${optional_libs} ${library1} ${library2} ${library3})
        endif (${variable})
      endif (${variable}3)
    endif (${variable}2)
  endif (${variable}1)
endmacro(optional3)
project(sox)

if(CMAKE_COMPILER_IS_GNUCC)
  add_definitions(-Wall -W -Wmissing-prototypes -Wstrict-prototypes -pedantic)
endif(CMAKE_COMPILER_IS_GNUCC)

include(TestBigEndian)

check_include_files("byteswap.h"         HAVE_BYTESWAP_H)
check_include_files("inttypes.h"         HAVE_INTTYPES_H)
check_include_files("io.h"               HAVE_IO_H)
#check_include_files("ltdl.h"             HAVE_LTDL_H) # no plug-ins as yet
check_include_files("stdint.h"           HAVE_STDINT_H)
check_include_files("string.h"           HAVE_STRING_H)
check_include_files("strings.h"          HAVE_STRINGS_H)
check_include_files("sys/time.h"         HAVE_SYS_TIME_H)
check_include_files("sys/timeb.h"        HAVE_SYS_TIMEB_H)
check_include_files("unistd.h"           HAVE_UNISTD_H)

check_function_exists("fseeko"           HAVE_FSEEKO)
check_function_exists("gettimeofday"     HAVE_GETTIMEOFDAY)
check_function_exists("popen"            HAVE_POPEN)
check_function_exists("strcasecmp"       HAVE_STRCASECMP)
check_function_exists("strdup"           HAVE_STRDUP)
check_function_exists("strrstr"          HAVE_STRRSTR)
check_function_exists("vsnprintf"        HAVE_VSNPRINTF)

test_big_endian(WORDS_BIGENDIAN)

optional(NEED_LIBM math.h m pow "")
if(NEED_LIBM)
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} -lm)
endif(NEED_LIBM)
optional(EXTERNAL_GSM gsm/gsm.h gsm gsm_create "")
optional(HAVE_ALSA alsa/asoundlib.h asound snd_pcm_open alsa)
optional(HAVE_AMRNB amrnb/sp_dec.h amrnb Decoder_Interface_init amr-nb)
optional(HAVE_AMRWB amrwb/dec.h amrwb D_IF_init amr-wb)
optional(HAVE_ID3TAG id3tag.h id3tag id3_file_open "")
optional(HAVE_LIBAO ao/ao.h ao ao_play ao)
optional(HAVE_FLAC FLAC/all.h FLAC FLAC__stream_encoder_new flac)
optional(HAVE_MAD_H mad.h mad mad_stream_buffer mp3)
optional(HAVE_LAME_LAME_H lame/lame.h mp3lame lame_init mp3)
if (NOT HAVE_LAME_LAME_H)
  optional(HAVE_LAME_LAME_H lame.h mp3lame lame_init mp3)
endif (NOT HAVE_LAME_LAME_H)
optional(HAVE_SAMPLERATE_H samplerate.h samplerate src_simple rabbit)
optional(HAVE_SNDFILE_H sndfile.h sndfile sf_open sndfile)
optional(HAVE_SNDFILE_1_0_12 sndfile.h sndfile sf_open_virtual "")
optional(HAVE_SUN_AUDIOIO_H sun/audioio.h c ioctl sunaudio)
if (NOT HAVE_SUN_AUDIOIO_H)
  optional(HAVE_SYS_AUDIOIO_H sys/audioio.h c ioctl sunaudio)
endif (NOT HAVE_SUN_AUDIOIO_H)
optional(HAVE_SYS_SOUNDCARD_H sys/soundcard.h c ioctl oss)
if (NOT HAVE_SYS_SOUNDCARD_H)
  optional(HAVE_MACHINE_SOUNDCARD_H machine/soundcard.h ossaudio _oss_ioctl oss)
endif (NOT HAVE_SYS_SOUNDCARD_H)
optional3(HAVE_OGG_VORBIS vorbis/codec.h vorbis vorbis_analysis_headerout vorbisfile ov_clear vorbisenc vorbis_encode_init_vbr vorbis)
optional3(HAVE_FFMPEG ffmpeg/avformat.h avformat av_open_input_file avutil av_rescale_q avcodec avcodec_decode_audio2 ffmpeg)

subdirs(src lpc10)

if (NOT EXTERNAL_GSM)
  add_subdirectory(libgsm)
endif (NOT EXTERNAL_GSM)

=== src/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}config.h)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(CMAKE_COMPILER_IS_GNUCC)
#  add_definitions(-Wconversion)
endif(CMAKE_COMPILER_IS_GNUCC)

if (NOT EXTERNAL_GSM)
  set(optional_libs ${optional_libs} gsm)
endif (NOT EXTERNAL_GSM)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/soxstdint.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/soxstdint.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/soxstdint.h
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/soxstdint.h.cmake
)

# Format with: !xargs echo|tr ' ' '\n'|sort|column|expand|sed 's/^/  /'
set(effects_srcs
  biquad          echos           noiseprof       resample        synth
  biquads         effects         noisered        reverb          tempo
  chorus          fade            pad             reverse         tremolo
  compand         FFT             pan             silence         trim
  compandt        filter          phaser          skeleff         vibro
  dcshift         flanger         pitch           speed           vol
  dither          key             polyphas        stat
  earwax          mcompand        rate            stretch
  echo            mixer           repeat          swap
)
set(formats_srcs
  8svx            cvsd            hcom            s1-fmt          u2-fmt
  adpcm           cvsd-fmt        ima-fmt         s2-fmt          u3-fmt
  adpcms          dat             ima_rw          s3-fmt          u4-fmt
  aifc-fmt        dvms-fmt        la-fmt          s4-fmt          ul-fmt
  aiff            formats         lpc10.c         sf              voc
  aiff-fmt        g711            lu-fmt          skelform        vox
  al-fmt          g721            maud            smp             vox-fmt
  au              g723_24         nulfile         sndrtool        wav
  auto            g723_40         prc             sphere          wve
  avr             g72x            raw             tx16w           xa
  cdr             gsm.c           raw-fmt         u1-fmt
)
add_library(lib${PROJECT_NAME}
  ${effects_srcs}         misc                    util
  ${formats_srcs}         ${optional_srcs}        xmalloc
  getopt                  soxio
  getopt1                 soxstdint
)
add_executable(${PROJECT_NAME} ${PROJECT_NAME}.c)
target_link_libraries(${PROJECT_NAME} lib${PROJECT_NAME} lpc10 ${optional_libs})
add_executable(sox_sample_test sox_sample_test.c)
add_executable(example1 example1.c)
target_link_libraries(example1 lib${PROJECT_NAME} lpc10 ${optional_libs})
find_program(LN ln)
if (LN)
  add_custom_target(rec ALL ${LN} -sf sox rec DEPENDS sox)
  add_custom_target(play ALL ${LN} -sf sox play DEPENDS sox)
endif (LN)
find_program(CTAGS NAMES exuberant-ctags ctags)
add_custom_target(tags ${CTAGS} --recurse --extra=fq ${CMAKE_CURRENT_SOURCE_DIR})

## sox 14.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+cmake_minimum_required(VERSION 2.4)
 include(CheckIncludeFiles)
 include(CheckFunctionExists)
 include(CheckLibraryExists)
@@ -32,13 +33,14 @@
 project(sox)
 
 if(CMAKE_COMPILER_IS_GNUCC)
-  add_definitions(-Wall -W -Wmissing-prototypes -Wstrict-prototypes -pedantic)
+  add_definitions(-D_FORTIFY_SOURCE=2 -Wall -W -Wmissing-prototypes -Wstrict-prototypes -pedantic)
 endif(CMAKE_COMPILER_IS_GNUCC)
 
 include(TestBigEndian)
 
 check_include_files("byteswap.h"         HAVE_BYTESWAP_H)
 check_include_files("inttypes.h"         HAVE_INTTYPES_H)
+check_include_files("glob.h"             HAVE_GLOB_H)
 check_include_files("io.h"               HAVE_IO_H)
 #check_include_files("ltdl.h"             HAVE_LTDL_H) # no plug-ins as yet
 check_include_files("stdint.h"           HAVE_STDINT_H)
@@ -46,13 +48,17 @@
 check_include_files("strings.h"          HAVE_STRINGS_H)
 check_include_files("sys/time.h"         HAVE_SYS_TIME_H)
 check_include_files("sys/timeb.h"        HAVE_SYS_TIMEB_H)
+check_include_files("sys/types.h"        HAVE_SYS_TYPES_H)
+check_include_files("sys/utsname.h"      HAVE_SYS_UTSNAME_H)
+check_include_files("termios.h"          HAVE_TERMIOS_H)
 check_include_files("unistd.h"           HAVE_UNISTD_H)
 
+check_function_exists("fmemopen"         HAVE_FMEMOPEN)
 check_function_exists("fseeko"           HAVE_FSEEKO)
 check_function_exists("gettimeofday"     HAVE_GETTIMEOFDAY)
+check_function_exists("mkstemp"          HAVE_MKSTEMP)
 check_function_exists("popen"            HAVE_POPEN)
 check_function_exists("strcasecmp"       HAVE_STRCASECMP)
-check_function_exists("strdup"           HAVE_STRDUP)
 check_function_exists("strrstr"          HAVE_STRRSTR)
 check_function_exists("vsnprintf"        HAVE_VSNPRINTF)
 
@@ -63,20 +69,40 @@
   set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} -lm)
 endif(NEED_LIBM)
 optional(EXTERNAL_GSM gsm/gsm.h gsm gsm_create "")
+optional(EXTERNAL_LPC10 lpc10/lpc10.h lpc10 lpc10_create "")
 optional(HAVE_ALSA alsa/asoundlib.h asound snd_pcm_open alsa)
 optional(HAVE_AMRNB amrnb/sp_dec.h amrnb Decoder_Interface_init amr-nb)
 optional(HAVE_AMRWB amrwb/dec.h amrwb D_IF_init amr-wb)
+if(CMAKE_COMPILER_IS_GNUCC)
+  optional(HAVE_OPENMP omp.h gomp omp_get_thread_num "")
+  if(HAVE_OPENMP)
+    add_definitions(-fopenmp)
+  endif(HAVE_OPENMP)
+endif(CMAKE_COMPILER_IS_GNUCC)
 optional(HAVE_ID3TAG id3tag.h id3tag id3_file_open "")
-optional(HAVE_LIBAO ao/ao.h ao ao_play ao)
+optional(HAVE_SNDIO CoreAudio/CoreAudio.h CoreAudio AudioHardwareGetProperty coreaudio)
+optional(HAVE_SNDIO sndio.h sndio sio_open sndio)
+optional(HAVE_AO ao/ao.h ao ao_play ao)
 optional(HAVE_FLAC FLAC/all.h FLAC FLAC__stream_encoder_new flac)
 optional(HAVE_MAD_H mad.h mad mad_stream_buffer mp3)
 optional(HAVE_LAME_LAME_H lame/lame.h mp3lame lame_init mp3)
 if (NOT HAVE_LAME_LAME_H)
   optional(HAVE_LAME_LAME_H lame.h mp3lame lame_init mp3)
 endif (NOT HAVE_LAME_LAME_H)
-optional(HAVE_SAMPLERATE_H samplerate.h samplerate src_simple rabbit)
-optional(HAVE_SNDFILE_H sndfile.h sndfile sf_open sndfile)
-optional(HAVE_SNDFILE_1_0_12 sndfile.h sndfile sf_open_virtual "")
+optional(HAVE_MAGIC magic.h magic magic_open "")
+#optional(HAVE_OGG_SPEEX speex/speex.h speex speex_decoder_init speex)
+optional(HAVE_PNG png.h png png_set_rows spectrogram)
+optional(HAVE_PULSEAUDIO pulse/simple.h pulse-simple pa_simple_new pulseaudio)
+optional(HAVE_SNDFILE sndfile.h sndfile sf_open sndfile)
+optional(HAVE_SNDFILE sndfile.h sndfile sf_open fap)
+optional(HAVE_SNDFILE sndfile.h sndfile sf_open mat4)
+optional(HAVE_SNDFILE sndfile.h sndfile sf_open mat5)
+optional(HAVE_SNDFILE sndfile.h sndfile sf_open paf)
+optional(HAVE_SNDFILE sndfile.h sndfile sf_open pvf)
+optional(HAVE_SNDFILE sndfile.h sndfile sf_open sd2)
+optional(HAVE_SNDFILE sndfile.h sndfile sf_open w64)
+optional(HAVE_SNDFILE sndfile.h sndfile sf_open xi)
+optional(HAVE_SNDFILE_1_0_12 sndfile.h sndfile sf_open_virtual caf)
 optional(HAVE_SUN_AUDIOIO_H sun/audioio.h c ioctl sunaudio)
 if (NOT HAVE_SUN_AUDIOIO_H)
   optional(HAVE_SYS_AUDIOIO_H sys/audioio.h c ioctl sunaudio)
@@ -87,10 +113,33 @@
 endif (NOT HAVE_SYS_SOUNDCARD_H)
 optional3(HAVE_OGG_VORBIS vorbis/codec.h vorbis vorbis_analysis_headerout vorbisfile ov_clear vorbisenc vorbis_encode_init_vbr vorbis)
 optional3(HAVE_FFMPEG ffmpeg/avformat.h avformat av_open_input_file avutil av_rescale_q avcodec avcodec_decode_audio2 ffmpeg)
+optional(HAVE_WAVPACK wavpack/wavpack.h wavpack WavpackGetSampleRate wavpack)
 
-subdirs(src lpc10)
+if (HAVE_LAME_LAME_H OR HAVE_MAD_H)
+  set(HAVE_MP3 1)
+endif (HAVE_LAME_LAME_H OR HAVE_MAD_H)
+
+set(CMAKE_REQUIRED_LIBRARIES mp3lame m)
+check_function_exists("lame_set_VBR_quality" HAVE_LAME_SET_VBR_QUALITY)
+check_function_exists("id3tag_set_fieldvalue" HAVE_ID3TAG_SET_FIELDVALUE)
+
+if (HAVE_SUN_AUDIOIO_H OR HAVE_SYS_AUDIOIO_H)
+  set(HAVE_SUN_AUDIO 1)
+endif (HAVE_SUN_AUDIOIO_H OR HAVE_SYS_AUDIOIO_H)
+
+if (HAVE_SYS_SOUNDCARD_H OR HAVE_MACHINE_SOUNDCARD_H)
+  set(HAVE_OSS 1)
+endif (HAVE_SYS_SOUNDCARD_H OR HAVE_MACHINE_SOUNDCARD_H)
+
+configure_file(sox.pc.in sox.pc @ONLY)
+install_files(/lib/pkgconfig FILES sox.pc)
+
+subdirs(src)
 
 if (NOT EXTERNAL_GSM)
   add_subdirectory(libgsm)
 endif (NOT EXTERNAL_GSM)
 
+if (NOT EXTERNAL_LPC10)
+  add_subdirectory(lpc10)
+endif (NOT EXTERNAL_LPC10)

=== lpc10/CMakeLists.txt ===
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/soxstdint.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/../src/soxstdint.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/soxstdint.h
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../src/soxstdint.h.cmake
)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(lpc10 analys bsynz chanwr dcbias decode deemp difmag dyptrk encode energy f2clib ham84 hp100 invert irc2pc ivfilt lpcdec lpcenc lpcini lpfilt median mload onset pitsyn placea placev preemp prepro random rcchk synths tbdm voicin vparms soxstdint)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/../src)

## sox 14.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,20 @@
     endif (${variable})
   endif (${variable}1)
 endmacro(optional)
+
+macro(optional2 variable header library1 function1 library2 function2 source)
+  check_include_files(${header} ${variable}1)
+  if (${variable}1)
+    check_library_exists(${library1} ${function1} "" ${variable}2)
+    if (${variable}2)
+      check_library_exists(${library2} ${function2} "" ${variable})
+      if (${variable})
+	set(optional_srcs ${optional_srcs} ${source})
+	set(optional_libs ${optional_libs} ${library1} ${library2})
+      endif (${variable})
+    endif (${variable}2)
+  endif (${variable}1)
+endmacro(optional2)
 
 macro(optional3 variable header library1 function1 library2 function2 library3 function3 source)
   check_include_files(${header} ${variable}1)
@@ -30,6 +44,27 @@
     endif (${variable}2)
   endif (${variable}1)
 endmacro(optional3)
+
+macro(optional4 variable header library1 function1 library2 function2 library3 function3 library4 function4 source)
+  check_include_files(${header} ${variable}1)
+  if (${variable}1)
+    check_library_exists(${library1} ${function1} "" ${variable}2)
+    if (${variable}2)
+      check_library_exists(${library2} ${function2} "" ${variable}3)
+      if (${variable}3)
+	check_library_exists(${library3} ${function3} "" ${variable}4)
+	if (${variable}4)
+	  check_library_exists(${library4} ${function4} "" ${variable})
+	  if (${variable})
+	    set(optional_srcs ${optional_srcs} ${source})
+	    set(optional_libs ${optional_libs} ${library1} ${library2} ${library3} ${library4})
+	  endif (${variable})
+	endif (${variable}4)
+      endif (${variable}3)
+    endif (${variable}2)
+  endif (${variable}1)
+endmacro(optional4)
+
 project(sox)
 
 if(CMAKE_COMPILER_IS_GNUCC)
@@ -91,8 +126,14 @@
 endif (NOT HAVE_LAME_LAME_H)
 optional(HAVE_MAGIC magic.h magic magic_open "")
 #optional(HAVE_OGG_SPEEX speex/speex.h speex speex_decoder_init speex)
-optional(HAVE_PNG png.h png png_set_rows spectrogram)
-optional(HAVE_PULSEAUDIO pulse/simple.h pulse-simple pa_simple_new pulseaudio)
+optional2(HAVE_PNG png.h png png_set_rows z uncompress spectrogram)
+if (HAVE_PNG)
+  check_library_exists(z uncompress "" spectrogram1)
+  if (${spectrogram1})
+    set(optional_libs ${optional_libs} z)
+  endif (${spectrogram1})
+endif (HAVE_PNG)
+optional2(HAVE_PULSEAUDIO pulse/simple.h pulse-simple pa_simple_new pulse pa_strerror pulseaudio)
 optional(HAVE_SNDFILE sndfile.h sndfile sf_open sndfile)
 optional(HAVE_SNDFILE sndfile.h sndfile sf_open fap)
 optional(HAVE_SNDFILE sndfile.h sndfile sf_open mat4)
@@ -111,7 +152,8 @@
 if (NOT HAVE_SYS_SOUNDCARD_H)
   optional(HAVE_MACHINE_SOUNDCARD_H machine/soundcard.h ossaudio _oss_ioctl oss)
 endif (NOT HAVE_SYS_SOUNDCARD_H)
-optional3(HAVE_OGG_VORBIS vorbis/codec.h vorbis vorbis_analysis_headerout vorbisfile ov_clear vorbisenc vorbis_encode_init_vbr vorbis)
+optional(HAVE_WAVEAUDIO mmsystem.h winmm waveInGetDevCapsA waveaudio)
+optional4(HAVE_OGG_VORBIS vorbis/codec.h ogg ogg_stream_flush vorbis vorbis_analysis_headerout vorbisfile ov_clear vorbisenc vorbis_encode_init_vbr vorbis)
 optional3(HAVE_FFMPEG ffmpeg/avformat.h avformat av_open_input_file avutil av_rescale_q avcodec avcodec_decode_audio2 ffmpeg)
 optional(HAVE_WAVPACK wavpack/wavpack.h wavpack WavpackGetSampleRate wavpack)

## sox 14.4.0

=== src/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}config.h)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(CMAKE_COMPILER_IS_GNUCC)
  execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
    OUTPUT_VARIABLE ver)
  string(REGEX REPLACE "([0-9]+)\\.([0-9]+).*" "\\1" major "${ver}")
  string(REGEX REPLACE "([0-9]+)\\.([0-9]+).*" "\\2" minor "${ver}")
  math(EXPR ver "100 * ${major} + ${minor}")
  if(${ver} LESS 403)
    add_definitions(-Wconversion)
  else(${ver} LESS 403)
    add_definitions(-Wtraditional-conversion)
  endif(${ver} LESS 403)
  #add_definitions(-Werror)
endif(CMAKE_COMPILER_IS_GNUCC)

if (NOT EXTERNAL_GSM)
  set(optional_libs ${optional_libs} gsm)
endif (NOT EXTERNAL_GSM)

set(effects_srcs
  bend
  biquad
  biquads
  chorus
  compand
  compandt
  contrast
  dcshift
  delay
  dft_filter
  dither
  divide
  downsample
  earwax
  echo
  echos
  fade
  fft4g
  fir
  firfit
  flanger
  gain
  hilbert
  input
  loudness
  mcompand
  mixer
  noiseprof
  noisered
  output
  overdrive
  pad
  phaser
  rate
  remix
  repeat
  reverb
  reverse
  silence
  sinc
  skeleff
  speed
  splice
  stat
  stats
  stretch
  swap
  synth
  tempo
  tremolo
  trim
  upsample
  vad
  vol
)
set(formats_srcs
  8svx
  adpcm
  adpcms
  aifc-fmt
  aiff
  aiff-fmt
  al-fmt
  au
  avr
  cdr
  cvsd
  cvsd-fmt
  dat
  dvms-fmt
  f4-fmt
  f8-fmt
  g711
  g721
  g723_24
  g723_40
  g72x
  gsm
  gsrt
  hcom
  htk
  ima-fmt
  ima_rw
  la-fmt
  lpc10
  lu-fmt
  maud
  nulfile
  prc
  raw
  raw-fmt
  s1-fmt
  s2-fmt
  s3-fmt
  s4-fmt
  sf
  skelform
  smp
  sounder
  soundtool
  sox-fmt
  sphere
  tx16w
  u1-fmt
  u2-fmt
  u3-fmt
  u4-fmt
  ul-fmt
  voc
  vox
  vox-fmt
  wav
  wve
  xa
)

# Uncomment for bit-rot detection on linux
#set(formats_srcs ${formats_srcs} coreaudio sndio sunaudio waveaudio)
#add_definitions(-Isrc/bit-rot)

add_library(lib${PROJECT_NAME}
  effects                 formats_i               libsox_i
  effects_i               ${formats_srcs}         ${optional_srcs}
  effects_i_dsp           getopt
  ${effects_srcs}         util
  formats                 libsox                  xmalloc
)
add_executable(${PROJECT_NAME} ${PROJECT_NAME}.c)
target_link_libraries(${PROJECT_NAME} lib${PROJECT_NAME} lpc10 ${optional_libs})
add_executable(sox_sample_test sox_sample_test.c)
add_executable(example0 example0.c)
target_link_libraries(example0 lib${PROJECT_NAME} lpc10 ${optional_libs})
add_executable(example1 example1.c)
target_link_libraries(example1 lib${PROJECT_NAME} lpc10 ${optional_libs})
add_executable(example2 example2.c)
target_link_libraries(example2 lib${PROJECT_NAME} lpc10 ${optional_libs})
add_executable(example3 example3.c)
target_link_libraries(example3 lib${PROJECT_NAME} lpc10 ${optional_libs})
add_executable(example4 example4.c)
target_link_libraries(example4 lib${PROJECT_NAME} lpc10 ${optional_libs})
add_executable(example5 example5.c)
target_link_libraries(example5 lib${PROJECT_NAME} lpc10 ${optional_libs})
find_program(LN ln)
if (LN)
  add_custom_target(rec ALL ${LN} -sf sox rec DEPENDS sox)
  add_custom_target(play ALL ${LN} -sf sox play DEPENDS sox)
  add_custom_target(soxi ALL ${LN} -sf sox soxi DEPENDS sox)
endif (LN)
find_program(CTAGS NAMES exuberant-ctags ctags)
add_custom_target(tags ${CTAGS} --recurse --extra=fq ${CMAKE_CURRENT_SOURCE_DIR})
